/*****************************/
/* kChat v1.5		     */
/* krzak@linux.net.pl        */ 
/* Marcin Krzyzanowski       */
/* http://krzak.linux.net.pl */
/* License: GPL              */
/*****************************/
/* Copyright (C) 2001  Marcin Krzyzanowski <krzak@linux.net.pl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.lang.*;
import java.net.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;

public class kChatChannel extends Component implements MouseListener {
    private static int pozX = 2;
    private int sizeX = 10;
    private int sizeY = 10;
    private int fontH = 0;
    private int startAt = 0;
    private static int len = 5;
    private Vector tekstList = null;
 
    private Vector colorList = null;
    private Graphics buforGraf;
    private Image bufor;
    private Dimension rozmiarBuf,d;
    private Image bgImage = null;
    private int bgImageX = 0;
    private int bgImageY = 0;
    public  boolean moderatorMode = false;
    private Vector butList = null;
    public FontMetrics fm = null;
    public Scrollbar sbar = null;

    public kChatChannel() {
    this.sizeX = 100;
    this.sizeY = 100;
    setSize(sizeX,sizeY);
    this.tekstList = new Vector();
    this.colorList = new Vector();
    this.d = new Dimension(sizeX,sizeY);
    if (moderatorMode) addMouseListener(this);
    }
    

    public kChatChannel(int x, int y) {
    this.sizeX = x;
    this.sizeY = y;
    setSize(x,y);
    this.tekstList = new Vector();
    this.colorList = new Vector();
    this.d = new Dimension(sizeX,sizeY);
    if (moderatorMode) addMouseListener(this);
    }
    
    public void setBackgroundImage(Image im)  { this.bgImage = im; }
    public void setScroller(Scrollbar sb) { this.sbar = sb; }

    public void moveStart(int pos) {
        startAt = pos;
        this.paint(this.getGraphics());
    }

    public void moveUp() {
     if ((startAt)>0) {
     startAt = startAt--;
     this.paint(this.getGraphics());
     }
    }

    public void moveDown() {
    if ((startAt+(len))<tekstList.size()) {
	startAt++;
	this.paint(this.getGraphics());
	}
    }

    public void appendText(String tekst, String color) {
    Color c = stringToColor(color);
    FontMetrics fm = this.getGraphics().getFontMetrics(getFont());
    int l = 0;
    if ((fm.stringWidth(tekst) + fm.getMaxAdvance())>(sizeX-pozX)) {
	int w = 0; int j=0; int i =0;
	for (i=0; i<tekst.length();i++) { 
		w = w + fm.charWidth(tekst.charAt(i));
		if ((w+fm.getMaxAdvance())>(sizeX-pozX)) { tekstList.addElement(tekst.substring(j,i-1)); 
					colorList.addElement(c); 
					w = 0; 
					j=i; 
					l++;
					}
		}
	tekstList.addElement(tekst.substring(j-1,i)); 
	colorList.addElement(c);
	l++;
	} else  { tekstList.addElement(tekst); l=1; colorList.addElement(c); }
    if (tekstList.size()>len) 
	{
	if (this.sbar != null) {
	    sbar.setValue(sbar.getValue()+l);
	    sbar.setMaximum(sbar.getMaximum()+l);
	    }
	startAt = startAt + l;
	}
    this.paint(this.getGraphics());
    }


   public void update(Graphics g) {
    int pozY = 0;
    if (moderatorMode) pozX = 40; else pozX = 2;
    
    if ( (buforGraf == null)  || (d.width != rozmiarBuf.width)  || (d.height != rozmiarBuf.height) ) 
	{
	rozmiarBuf = d;
	bufor = createImage(d.width,d.height);
	buforGraf = bufor.getGraphics();
	}    

    buforGraf.setFont(getFont());

    buforGraf.setColor(getBackground());
    buforGraf.fillRect(0, 0, d.width, d.height);

    if (bgImage != null) buforGraf.drawImage(bgImage,bgImageX,bgImageY,this);
    
    FontMetrics fm = getFontMetrics(getFont());
    fontH = fm.getHeight();
    len = (this.sizeY / fontH);
    
    if ((moderatorMode) && (butList == null)) { 
	  butList = new Vector(len); 
	  butList.setSize(len);
	  addMouseListener(this);
	}
    pozY = fm.getMaxAscent();
      	for (int i=startAt;((i<tekstList.size()) && ((i-startAt)<len));i++) {
		buforGraf.setColor((Color)colorList.elementAt(i));
		buforGraf.drawString((String)tekstList.elementAt(i),pozX,pozY); 

	    if (moderatorMode) {
		kChatButton but = new kChatButton();
		String ss = (String)tekstList.elementAt(i);
		if (ss.startsWith("<"))	but.drawButton(buforGraf,0,pozY-fontH,39,fontH,(String)tekstList.elementAt(i),i);
		butList.setElementAt(but,i-startAt);
		}
		
		pozY=pozY+fontH;
		}
    g.drawImage(bufor, 0, 0, this);
    }

    public void mouseEntered(MouseEvent event) {
    }
    public void mouseExited(MouseEvent event) {
    }
    public void mousePressed(MouseEvent event) {
    }
    public void mouseReleased(MouseEvent event) {
    }
    public void mouseClicked(MouseEvent event) {
	if (moderatorMode) {
	    kChatButton tmpB = new kChatButton();
	    for (int i=0; i<butList.size(); i++) {
		tmpB = (kChatButton)butList.elementAt(i);
		if ((tmpB != null )&&(event.getX()>tmpB.x1) && (event.getX()<tmpB.x2) && (event.getY()>tmpB.y1) && (event.getY()<tmpB.y2))
		    {
		    Vector linijki = new Vector();
		    String colSt = colorToString( (Color)colorList.elementAt(tmpB.index) );
		    String s = (String)tekstList.elementAt(tmpB.index);
		    linijki.addElement(s);
		    tekstList.removeElement(s);
		    int j=0;
		    while (tekstList.size()>(tmpB.index+j)) {
			String sn = (String)tekstList.elementAt(tmpB.index+j);
			if (!sn.startsWith("<")) { 
			    s = s + sn; linijki.addElement(sn); j++;
			    }  else break;
			}

		    if (linijki != null)
			for (int ii=0;ii<linijki.size();ii++) tekstList.removeElement(linijki.elementAt(ii));
		    this.paint(this.getGraphics());
		    kChatApplet.net.send("*MSG|" + kChatApplet.login + "|CHAN|" + s + "|" + colSt + "|"); 
		    }
		//zielony
		if ((tmpB != null )&&(event.getX()>tmpB.x3) && (event.getX()<tmpB.x4) && (event.getY()>tmpB.y3) && (event.getY()<tmpB.y4))
		    {
		    Vector linijki = new Vector();
		    String colSt = colorToString( (Color)colorList.elementAt(tmpB.index) );
		    String s = (String)tekstList.elementAt(tmpB.index);
		    linijki.addElement(s);
		    tekstList.removeElement(s);
		    int j=0;
		    while (tekstList.size()>(tmpB.index+j)) {
			String sn = (String)tekstList.elementAt(tmpB.index+j);
			if (!sn.startsWith("<")) { 
			    s = s + sn; linijki.addElement(sn); j++;
			    }  else break;
			}

		    if (linijki != null)
			for (int ii=0;ii<linijki.size();ii++) tekstList.removeElement(linijki.elementAt(ii));
		    this.paint(this.getGraphics());
		    }


	    }
	}
    }


    public Color stringToColor(String color)
    {
    Color c = Color.white;
    if (color.equals("white")) { c = Color.white; }
    if (color.equals("yellow")) { c = Color.yellow; }
    if (color.equals("red")) {  c = Color.red; }
    if (color.equals("black")) { c = Color.black; }
    if (color.equals("green")) { c = Color.green; }
    if (color.equals("gray")) {  c = Color.darkGray; }
    return(c);
    }

    public String colorToString(Color color)
    {
    String s = "";
    if (color.equals(Color.white)) { s = "white"; }
    if (color.equals(Color.yellow)) { s = "yellow"; }
    if (color.equals(Color.red)) { s = "red"; }
    if (color.equals(Color.black)) { s = "black"; }
    if (color.equals(Color.green)) { s = "green"; }
    if (color.equals(Color.darkGray)) { s = "gray"; }
    return(s);
    }

    public void paint(Graphics g) { update(g); }
    public Dimension getPreferredSize() {
 return getSize(); 
}


}
