/*****************************/
/* kChat v1.5		     */
/* krzak@linux.net.pl        */ 
/* Marcin Krzyzanowski       */
/* http://krzak.linux.net.pl */
/* License: GPL              */
/*****************************/
/* Copyright (C) 2001  Marcin Krzyzanowski <krzak@linux.net.pl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.util.*;
import java.io.*;

public class kChatSystem {
	
    public static boolean moderated   = false;
    public static Vector  clientList = new Vector();
    public static String lastError = "";
    public static String moderatorNick = "";
    public static String guestNick = "";
	
    public static void sayToAll(String s) {
    kChatClass tmpE = null;
    for (int i = 0; i < clientList.size(); i++) {
	  tmpE = (kChatClass)clientList.elementAt(i);
          tmpE.watek.pw.println(s+"\r\n");
          tmpE.watek.pw.flush();									  
	 }           
    // LOGOWANIE
    
    int pozcE = s.indexOf("|");
    if (s.substring(0,pozcE).startsWith("*MSG"))
	{
	int pozwE = s.indexOf("|",pozcE+1);
	int pozwhE = s.indexOf("|",pozwE+1);
	int poztE = s.indexOf("|",pozwhE+1);
	int pozcolE = s.indexOf("|",poztE+1);
	String st = new String();
	st = "<" + s.substring(pozcE+1,pozwE); 
// ludek
	st = st + "> " + s.substring(pozwhE+1,poztE);

        try {
    	    FileWriter fw = new FileWriter("./chanlog.log",true);
	    BufferedWriter fwb = new BufferedWriter(fw);
	    fwb.write(st,0,st.length());
	    fwb.newLine();
	    fwb.flush();
	    fwb.close();
	    } catch (IOException e) { e.printStackTrace(); };
	}
    }

    // LOGIN
    public static boolean loginToSystem(String login, kChatServerThread th)
    {
    if (clientList == null) clientList = new Vector();
    if ((login == null) || (login.equals(""))) return(false);
    login = login.replace(' ', '_');
    login = login.replace('|', '_');
    login = login.replace('<', '_');
    login = login.replace('>', '_');
    for (int i = 0; i < clientList.size(); i++) {
				kChatClass tmpE = (kChatClass)clientList.elementAt(i);
				if (tmpE.login.equals(login))  
				    { 
				    lastError = "NICK BUSY"; return(false); 
				    }
				}

     kChatClass tmpC = new kChatClass();
     tmpC.login = login;
     tmpC.watek = th;
     tmpC.perm = 0;
     clientList.addElement(tmpC);
     lastError="";
     sayToAll("*JOIN|"+login+"|");
     return(true);
    }

   // CLOSE
   public static boolean quitFromSystem(String login)
   {
    int poz = -1;
    if (clientList==null) clientList = new Vector();
    for (int i = 0; i < clientList.size(); i++) {
					kChatClass tmpE = (kChatClass)clientList.elementAt(i);
					if (tmpE.login.equals(login))  { poz = i; }
				      }  
    if (login != null) sayToAll("*QUIT|"+login+"|");

    if (poz != -1) clientList.removeElementAt(poz); 
    if (login.equals(moderatorNick))
	    {
	    moderatorNick = "";
	    guestNick = "";
	    moderated = false;
	    sayToAll("*MODERATED|NO|");
	    }

    return(true);
    }

    // MSG
    public static void sendMsgTo(String from, String to, String text, String color)
    {
    String action = "*MSG";
    kChatClass tmpE = new kChatClass();
    if (moderated)  
	{ 
	to = moderatorNick;
	if (from.equals(guestNick)) { to = "CHAN"; }
	if (from.equals(moderatorNick)) { to = "CHAN"; }
	}
     // priv
//    if (clientList.contains(new String(from)))
    boolean cantalk = false;
    for (int i = 0; i < clientList.size(); i++) {
	tmpE = (kChatClass)clientList.elementAt(i);
	if (tmpE.login.equals(from)) cantalk = true; 
	}

    if (cantalk)
     if ((!to.equals("CHAN")) && (!to.equals("MODER"))) {
      int poz = -1;
      for (int i = 0; i < clientList.size(); i++) {
	tmpE = (kChatClass)clientList.elementAt(i);
	if (tmpE.login.equals(to))  { poz = i; }
        }     
      if (poz != -1) {
        tmpE = (kChatClass)clientList.elementAt(poz);
        tmpE.watek.pw.println(action +"|"+from+"|"+to+"|"+text+"|" + color + "|\r\n");
        tmpE.watek.pw.flush();
        }
      } 
      else sayToAll(action + "|"+from+"|"+to+"|"+text+"|" + color +"|");
    }

}